package si.formias.gentian;

import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;
import si.formias.gentian.R;

public class CountryPhone {
	final static Map<String, String> countrycode = new HashMap<String, String>();
	final static Map<String, String> operatortocountry = new HashMap<String, String>();

	static void add(String country, String iso, String phonecode) {
		StringBuilder sb = new StringBuilder();
		for (char c : phonecode.toCharArray()) {
			if (c >= '1' && c <= '9') {
				sb.append(c);
			}
		}
		String phone = sb.toString();
		StringTokenizer st = new StringTokenizer(iso, "/");
		while (st.hasMoreTokens()) {
			String code = st.nextToken().trim();
			if (code.length() > 0) {
				countrycode.put(code, phone);
			}
		}
	}

	static void operator(int operator, String iso, String country) {
		operatortocountry.put(Integer.toString(operator), iso);
	}

	public static String prefixForOperator(String simOperator) {
		return "+"
				+ countrycode.get(operatortocountry.get(simOperator.substring(
						0, 3)));
	}

	static {
		operator(412, "AF", "Afghanistan");
		operator(276, "AL", "Albania");
		operator(603, "DZ", "Algeria");
		operator(544, "AS", "American Samoa (US)");
		operator(213, "AD", "Andorra");
		operator(631, "AO", "Angola");
		operator(365, "AI", "Anguilla");
		operator(344, "AG", "Antigua and Barbuda");
		operator(722, "AR", "Argentine Republic");
		operator(283, "AM", "Armenia");
		operator(363, "AW", "Aruba (Netherlands)");
		operator(505, "AU", "Australia");
		operator(232, "AT", "Austria");
		operator(400, "AZ", "Azerbaijani Republic");
		operator(364, "BS", "Bahamas");
		operator(426, "BH", "Bahrain");
		operator(470, "BD", "Bangladesh");
		operator(342, "BB", "Barbados");
		operator(257, "BY", "Belarus");
		operator(206, "BE", "Belgium");
		operator(702, "BZ", "Belize");
		operator(616, "BJ", "Benin");
		operator(350, "BM", "Bermuda (UK)");
		operator(402, "BT", "Bhutan");
		operator(736, "BO", "Bolivia");
		operator(218, "BA", "Bosnia and Herzegovina");
		operator(652, "BW", "Botswana");
		operator(724, "BR", "Brazil");
		operator(348, "VG", "British Virgin Islands (UK)");
		operator(528, "BN", "Brunei Darussalam");
		operator(284, "BG", "Bulgaria");
		operator(613, "BF", "Burkina Faso");
		operator(642, "BI", "Burundi");
		operator(456, "KH", "Cambodia");
		operator(624, "CM", "Cameroon");
		operator(302, "CA", "Canada");
		operator(625, "CV", "Cape Verde");
		operator(346, "KY", "Cayman Islands (UK)");
		operator(623, "CF", "Central African Republic");
		operator(622, "TD", "Chad");
		operator(730, "CL", "Chile");
		operator(460, "CN", "China");
		operator(461, "CN", "China");
		operator(732, "CO", "Colombia");
		operator(654, "KM", "Comoros");
		operator(629, "CG", "Republic of the Congo");
		operator(548, "CK", "Cook Islands (NZ)");
		operator(712, "CR", "Costa Rica");
		operator(612, "CI", "Côte d'Ivoire");
		operator(219, "HR", "Croatia");
		operator(368, "CU", "Cuba");
		operator(362, "CW", "Curaçao (Netherlands)");
		operator(280, "CY", "Cyprus");
		operator(230, "CZ", "Czech Republic");
		operator(630, "CD", "Democratic Republic of the Congo");
		operator(238, "DK", "Denmark");
		operator(638, "DJ", "Djibouti");
		operator(366, "DM", "Dominica");
		operator(370, "DO", "Dominican Republic");
		operator(514, "TL", "East Timor");
		operator(740, "EC", "Ecuador");
		operator(602, "EG", "Egypt");
		operator(706, "SV", "El Salvador");
		operator(627, "GQ", "Equatorial Guinea");
		operator(657, "ER", "Eritrea");
		operator(248, "EE", "Estonia");
		operator(636, "ET", "Ethiopia");
		operator(750, "FK", "Falkland Islands (Malvinas)");
		operator(288, "FO", "Faroe Islands (Denmark)");
		operator(542, "FJ", "Fiji");
		operator(244, "FI", "Finland");
		operator(208, "FR", "France");
		operator(742, "GF", "French Guiana (France)");
		operator(547, "PF", "French Polynesia (France)");
		operator(628, "GA", "Gabonese Republic");
		operator(607, "GM", "Gambia");
		operator(282, "GE", "Georgia");
		operator(262, "DE", "Germany");
		operator(620, "GH", "Ghana");
		operator(266, "GI", "Gibraltar (UK)");
		operator(202, "GR", "Greece");
		operator(290, "GL", "Greenland (Denmark)");
		operator(352, "GD", "Grenada");
		operator(340, "GP", "Guadeloupe (France)");
		operator(535, "GU", "Guam (US)");
		operator(704, "GT", "Guatemala");
		operator(611, "GN", "Guinea");
		operator(632, "GW", "Guinea-Bissau");
		operator(738, "GY", "Guyana");
		operator(372, "HT", "Haiti");
		operator(708, "HN", "Honduras");
		operator(454, "HK", "Hong Kong (PRC)");
		operator(216, "HU", "Hungary");
		operator(274, "IS", "Iceland");
		operator(404, "IN", "India");
		operator(405, "IN", "India");
		operator(406, "IN", "India");
		operator(510, "ID", "Indonesia");
		operator(432, "IR", "Iran");
		operator(418, "IQ", "Iraq");
		operator(272, "IE", "Ireland");
		operator(425, "IL", "Israel");
		operator(222, "IT", "Italy");
		operator(338, "JM", "Jamaica");
		operator(441, "JP", "Japan");
		operator(440, "JP", "Japan");
		operator(416, "JO", "Jordan");
		operator(401, "KZ", "Kazakhstan");
		operator(639, "KE", "Kenya");
		operator(545, "KI", "Kiribati");
		operator(467, "KP", "Korea, North");
		operator(450, "KR", "Korea, South");
		operator(419, "KW", "Kuwait");
		operator(437, "KG", "Kyrgyz Republic");
		operator(457, "LA", "Laos");
		operator(247, "LV", "Latvia");
		operator(415, "LB", "Lebanon");
		operator(651, "LS", "Lesotho");
		operator(618, "LR", "Liberia");
		operator(606, "LY", "Libya");
		operator(295, "LI", "Liechtenstein");
		operator(246, "LT", "Lithuania");
		operator(270, "LU", "Luxembourg");
		operator(455, "MO", "Macau (PRC)");
		operator(294, "MK", "Republic of Macedonia");
		operator(646, "MG", "Madagascar");
		operator(650, "MW", "Malawi");
		operator(502, "MY", "Malaysia");
		operator(472, "MV", "Maldives");
		operator(610, "ML", "Mali");
		operator(278, "MT", "Malta");
		operator(551, "MH", "Marshall Islands");
		operator(340, "MQ", "Martinique (France)");
		operator(609, "MR", "Mauritania");
		operator(617, "MU", "Mauritius");
		operator(334, "MX", "Mexico");
		operator(550, "FM", "Federated States of Micronesia");
		operator(259, "MD", "Moldova");
		operator(212, "MC", "Monaco");
		operator(428, "MN", "Mongolia");
		operator(297, "ME", "Montenegro (Republic of)");
		operator(354, "MS", "Montserrat (UK)");
		operator(604, "MA", "Morocco");
		operator(643, "MZ", "Mozambique");
		operator(414, "MM", "Myanmar");
		operator(649, "NA", "Namibia");
		operator(536, "NR", "Nauru");
		operator(429, "NP", "Nepal");
		operator(204, "NL", "Netherlands");
		operator(546, "NC", "New Caledonia (France)");
		operator(530, "NZ", "New Zealand");
		operator(710, "NI", "Nicaragua");
		operator(614, "NE", "Niger");
		operator(621, "NG", "Nigeria");
		operator(555, "NU", "Niue");
		operator(534, "MP", "Northern Mariana Islands (US)");
		operator(242, "NO", "Norway");
		operator(422, "OM", "Oman");
		operator(410, "PK", "Pakistan");
		operator(552, "PW", "Palau");
		operator(425, "PS", "Palestine");
		operator(714, "PA", "Panama");
		operator(537, "PG", "Papua New Guinea");
		operator(744, "PY", "Paraguay");
		operator(716, "PE", "Perú");
		operator(515, "PH", "Philippines");
		operator(260, "PL", "Poland");
		operator(268, "PT", "Portugal");
		operator(330, "PR", "Puerto Rico (US)");
		operator(427, "QA", "Qatar");
		operator(647, "RE", "Réunion (France)");
		operator(226, "RO", "Romania");
		operator(250, "RU", "Russian Federation");
		operator(635, "RW", "Rwandese Republic");
		operator(356, "KN", "Saint Kitts and Nevis");
		operator(358, "LC", "Saint Lucia");
		operator(308, "PM", "Saint Pierre and Miquelon (France)");
		operator(360, "VC", "Saint Vincent and the Grenadines");
		operator(549, "WS", "Samoa");
		operator(292, "SM", "San Marino");
		operator(626, "ST", "São Tomé and Príncipe");
		operator(420, "SA", "Saudi Arabia");
		operator(608, "SN", "Senegal");
		operator(220, "RS", "Serbia (Republic of)");
		operator(633, "SC", "Seychelles");
		operator(619, "SL", "Sierra Leone");
		operator(525, "SG", "Singapore");
		operator(231, "SK", "Slovakia");
		operator(293, "SI", "Slovenia");
		operator(540, "SB", "Solomon Islands");
		operator(637, "SO", "Somalia");
		operator(655, "ZA", "South Africa");
		operator(214, "ES", "Spain");
		operator(413, "LK", "Sri Lanka");
		operator(634, "SD", "Sudan");
		operator(746, "SR", "Suriname");
		operator(653, "SZ", "Swaziland");
		operator(240, "SE", "Sweden");
		operator(228, "CH", "Switzerland");
		operator(417, "SY", "Syria");
		operator(466, "TW", "Taiwan");
		operator(436, "TJ", "Tajikistan");
		operator(640, "TZ", "Tanzania");
		operator(520, "TH", "Thailand");
		operator(615, "TG", "Togolese Republic");
		operator(539, "TO", "Tonga");
		operator(374, "TT", "Trinidad and Tobago");
		operator(605, "TN", "Tunisia");
		operator(286, "TR", "Turkey");
		operator(438, "TM", "Turkmenistan");
		operator(376, "TC", "Turks and Caicos Islands (UK)");
		operator(641, "UG", "Uganda");
		operator(255, "UA", "Ukraine");
		operator(424, "AE", "United Arab Emirates");
		operator(430, "AE", "United Arab Emirates");
		operator(431, "AE", "United Arab Emirates");
		operator(235, "GB", "United Kingdom");
		operator(234, "GB", "United Kingdom");
		operator(310, "US", "United States of America");
		operator(311, "US", "United States of America");
		operator(312, "US", "United States of America");
		operator(313, "US", "United States of America");
		operator(314, "US", "United States of America");
		operator(315, "US", "United States of America");
		operator(316, "US", "United States of America");
		operator(332, "VI", "United States Virgin Islands (US)");
		operator(748, "UY", "Uruguay");
		operator(434, "UZ", "Uzbekistan");
		operator(541, "VU", "Vanuatu");
		operator(225, "VA", "Vatican City State");
		operator(734, "VE", "Venezuela");
		operator(452, "VN", "Viet Nam");
		operator(543, "WF", "Wallis and Futuna (France)");
		operator(421, "YE", "Yemen");
		operator(645, "ZM", "Zambia");
		operator(648, "ZW", "Zimbabwe");
	}
	static {
		add("Afghanistan ", "AF / AFG ", "93 ");
		add("Albania ", "AL / ALB ", "355 ");
		add("Algeria ", "DZ / DZA ", "213 ");
		add("American Samoa ", "AS / ASM ", "1 684 ");
		add("Andorra ", "AD / AND ", "376 ");
		add("Angola ", "AO / AGO ", "244 ");
		add("Anguilla ", "AI / AIA ", "1 264 ");
		add("Antarctica ", "AQ / ATA ", "672 ");
		add("Antigua and Barbuda ", "AG / ATG ", "1 268 ");
		add("Argentina ", "AR / ARG ", "54 ");
		add("Armenia ", "AM / ARM ", "374 ");
		add("Aruba ", "AW / ABW ", "297 ");
		add("Australia ", "AU / AUS ", "61 ");
		add("Austria ", "AT / AUT ", "43 ");
		add("Azerbaijan ", "AZ / AZE ", "994 ");
		add("Bahamas ", "BS / BHS ", "1 242 ");
		add("Bahrain ", "BH / BHR ", "973 ");
		add("Bangladesh ", "BD / BGD ", "880 ");
		add("Barbados ", "BB / BRB ", "1 246 ");
		add("Belarus ", "BY / BLR ", "375 ");
		add("Belgium ", "BE / BEL ", "32 ");
		add("Belize ", "BZ / BLZ ", "501 ");
		add("Benin ", "BJ / BEN ", "229 ");
		add("Bermuda ", "BM / BMU ", "1 441 ");
		add("Bhutan ", "BT / BTN ", "975 ");
		add("Bolivia ", "BO / BOL ", "591 ");
		add("Bosnia and Herzegovina ", "BA / BIH ", "387 ");
		add("Botswana ", "BW / BWA ", "267 ");
		add("Brazil ", "BR / BRA ", "55 ");
		add("British Indian Ocean Territory ", "IO / IOT ", " ");
		add("British Virgin Islands ", "VG / VGB ", "1 284 ");
		add("Brunei ", "BN / BRN ", "673 ");
		add("Bulgaria ", "BG / BGR ", "359 ");
		add("Burkina Faso ", "BF / BFA ", "226 ");
		add("Burma (Myanmar) ", "MM / MMR ", "95 ");
		add("Burundi ", "BI / BDI ", "257 ");
		add("Cambodia ", "KH / KHM ", "855 ");
		add("Cameroon ", "CM / CMR ", "237 ");
		add("Canada ", "CA / CAN ", "1 ");
		add("Cape Verde ", "CV / CPV ", "238 ");
		add("Cayman Islands ", "KY / CYM ", "1 345 ");
		add("Central African Republic ", "CF / CAF ", "236 ");
		add("Chad ", "TD / TCD ", "235 ");
		add("Chile ", "CL / CHL ", "56 ");
		add("China ", "CN / CHN ", "86 ");
		add("Christmas Island ", "CX / CXR ", "61 ");
		add("Cocos (Keeling) Islands ", "CC / CCK ", "61 ");
		add("Colombia ", "CO / COL ", "57 ");
		add("Comoros ", "KM / COM ", "269 ");
		add("Cook Islands ", "CK / COK ", "682 ");
		add("Costa Rica ", "CR / CRC ", "506 ");
		add("Croatia ", "HR / HRV ", "385 ");
		add("Cuba ", "CU / CUB ", "53 ");
		add("Cyprus ", "CY / CYP ", "357 ");
		add("Czech Republic ", "CZ / CZE ", "420 ");
		add("Democratic Republic of the Congo ", "CD / COD ", "243 ");
		add("Denmark ", "DK / DNK ", "45 ");
		add("Djibouti ", "DJ / DJI ", "253 ");
		add("Dominica ", "DM / DMA ", "1 767 ");
		add("Dominican Republic ", "DO / DOM ", "1 809 ");
		add("Ecuador ", "EC / ECU ", "593 ");
		add("Egypt ", "EG / EGY ", "20 ");
		add("El Salvador ", "SV / SLV ", "503 ");
		add("Equatorial Guinea ", "GQ / GNQ ", "240 ");
		add("Eritrea ", "ER / ERI ", "291 ");
		add("Estonia ", "EE / EST ", "372 ");
		add("Ethiopia ", "ET / ETH ", "251 ");
		add("Falkland Islands ", "FK / FLK ", "500 ");
		add("Faroe Islands ", "FO / FRO ", "298 ");
		add("Fiji ", "FJ / FJI ", "679 ");
		add("Finland ", "FI / FIN ", "358 ");
		add("France ", "FR / FRA ", "33 ");
		add("French Polynesia ", "PF / PYF ", "689 ");
		add("Gabon ", "GA / GAB ", "241 ");
		add("Gambia ", "GM / GMB ", "220 ");
		add("Gaza Strip ", "/  ", "970 ");
		add("Georgia ", "GE / GEO ", "995 ");
		add("Germany ", "DE / DEU ", "49 ");
		add("Ghana ", "GH / GHA ", "233 ");
		add("Gibraltar ", "GI / GIB ", "350 ");
		add("Greece ", "GR / GRC ", "30 ");
		add("Greenland ", "GL / GRL ", "299 ");
		add("Grenada ", "GD / GRD ", "1 473 ");
		add("Guam ", "GU / GUM ", "1 671 ");
		add("Guatemala ", "GT / GTM ", "502 ");
		add("Guinea ", "GN / GIN ", "224 ");
		add("Guinea-Bissau ", "GW / GNB ", "245 ");
		add("Guyana ", "GY / GUY ", "592 ");
		add("Haiti ", "HT / HTI ", "509 ");
		add("Holy See (Vatican City) ", "VA / VAT ", "39 ");
		add("Honduras ", "HN / HND ", "504 ");
		add("Hong Kong ", "HK / HKG ", "852 ");
		add("Hungary ", "HU / HUN ", "36 ");
		add("Iceland ", "IS / IS ", "354 ");
		add("India ", "IN / IND ", "91 ");
		add("Indonesia ", "ID / IDN ", "62 ");
		add("Iran ", "IR / IRN ", "98 ");
		add("Iraq ", "IQ / IRQ ", "964 ");
		add("Ireland ", "IE / IRL ", "353 ");
		add("Isle of Man ", "IM / IMN ", "44 ");
		add("Israel ", "IL / ISR ", "972 ");
		add("Italy ", "IT / ITA ", "39 ");
		add("Ivory Coast ", "CI / CIV ", "225 ");
		add("Jamaica ", "JM / JAM ", "1 876 ");
		add("Japan ", "JP / JPN ", "81 ");
		add("Jersey ", "JE / JEY ", " ");
		add("Jordan ", "JO / JOR ", "962 ");
		add("Kazakhstan ", "KZ / KAZ ", "7 ");
		add("Kenya ", "KE / KEN ", "254 ");
		add("Kiribati ", "KI / KIR ", "686 ");
		add("Kosovo ", "XK/  ", "381 ");
		add("Kuwait ", "KW / KWT ", "965 ");
		add("Kyrgyzstan ", "KG / KGZ ", "996 ");
		add("Laos ", "LA / LAO ", "856 ");
		add("Latvia ", "LV / LVA ", "371 ");
		add("Lebanon ", "LB / LBN ", "961 ");
		add("Lesotho ", "LS / LSO ", "266 ");
		add("Liberia ", "LR / LBR ", "231 ");
		add("Libya ", "LY / LBY ", "218 ");
		add("Liechtenstein ", "LI / LIE ", "423 ");
		add("Lithuania ", "LT / LTU ", "370 ");
		add("Luxembourg ", "LU / LUX ", "352 ");
		add("Macau ", "MO / MAC ", "853 ");
		add("Macedonia ", "MK / MKD ", "389 ");
		add("Madagascar ", "MG / MDG ", "261 ");
		add("Malawi ", "MW / MWI ", "265 ");
		add("Malaysia ", "MY / MYS ", "60 ");
		add("Maldives ", "MV / MDV ", "960 ");
		add("Mali ", "ML / MLI ", "223 ");
		add("Malta ", "MT / MLT ", "356 ");
		add("Marshall Islands ", "MH / MHL ", "692 ");
		add("Mauritania ", "MR / MRT ", "222 ");
		add("Mauritius ", "MU / MUS ", "230 ");
		add("Mayotte ", "YT / MYT ", "262 ");
		add("Mexico ", "MX / MEX ", "52 ");
		add("Micronesia ", "FM / FSM ", "691 ");
		add("Moldova ", "MD / MDA ", "373 ");
		add("Monaco ", "MC / MCO ", "377 ");
		add("Mongolia ", "MN / MNG ", "976 ");
		add("Montenegro ", "ME / MNE ", "382 ");
		add("Montserrat ", "MS / MSR ", "1 664 ");
		add("Morocco ", "MA / MAR ", "212 ");
		add("Mozambique ", "MZ / MOZ ", "258 ");
		add("Namibia ", "NA / NAM ", "264 ");
		add("Nauru ", "NR / NRU ", "674 ");
		add("Nepal ", "NP / NPL ", "977 ");
		add("Netherlands ", "NL / NLD ", "31 ");
		add("Netherlands Antilles ", "AN / ANT ", "599 ");
		add("New Caledonia ", "NC / NCL ", "687 ");
		add("New Zealand ", "NZ / NZL ", "64 ");
		add("Nicaragua ", "NI / NIC ", "505 ");
		add("Niger ", "NE / NER ", "227 ");
		add("Nigeria ", "NG / NGA ", "234 ");
		add("Niue ", "NU / NIU ", "683 ");
		add("Norfolk Island ", "/ NFK ", "672 ");
		add("North Korea ", "KP / PRK ", "850 ");
		add("Northern Mariana Islands ", "MP / MNP ", "1 670 ");
		add("Norway ", "NO / NOR ", "47 ");
		add("Oman ", "OM / OMN ", "968 ");
		add("Pakistan ", "PK / PAK ", "92 ");
		add("Palau ", "PW / PLW ", "680 ");
		add("Panama ", "PA / PAN ", "507 ");
		add("Papua New Guinea ", "PG / PNG ", "675 ");
		add("Paraguay ", "PY / PRY ", "595 ");
		add("Peru ", "PE / PER ", "51 ");
		add("Philippines ", "PH / PHL ", "63 ");
		add("Pitcairn Islands ", "PN / PCN ", "870 ");
		add("Poland ", "PL / POL ", "48 ");
		add("Portugal ", "PT / PRT ", "351 ");
		add("Puerto Rico ", "PR / PRI ", "1 ");
		add("Qatar ", "QA / QAT ", "974 ");
		add("Republic of the Congo ", "CG / COG ", "242 ");
		add("Romania ", "RO / ROU ", "40 ");
		add("Russia ", "RU / RUS ", "7 ");
		add("Rwanda ", "RW / RWA ", "250 ");
		add("Saint Barthelemy ", "BL / BLM ", "590 ");
		add("Saint Helena ", "SH / SHN ", "290 ");
		add("Saint Kitts and Nevis ", "KN / KNA ", "1 869 ");
		add("Saint Lucia ", "LC / LCA ", "1 758 ");
		add("Saint Martin ", "MF / MAF ", "1 599 ");
		add("Saint Pierre and Miquelon ", "PM / SPM ", "508 ");
		add("Saint Vincent and the Grenadines ", "VC / VCT ", "1 784 ");
		add("Samoa ", "WS / WSM ", "685 ");
		add("San Marino ", "SM / SMR ", "378 ");
		add("Sao Tome and Principe ", "ST / STP ", "239 ");
		add("Saudi Arabia ", "SA / SAU ", "966 ");
		add("Senegal ", "SN / SEN ", "221 ");
		add("Serbia ", "RS / SRB ", "381 ");
		add("Seychelles ", "SC / SYC ", "248 ");
		add("Sierra Leone ", "SL / SLE ", "232 ");
		add("Singapore ", "SG / SGP ", "65 ");
		add("Slovakia ", "SK / SVK ", "421 ");
		add("Slovenia ", "SI / SVN ", "386 ");
		add("Solomon Islands ", "SB / SLB ", "677 ");
		add("Somalia ", "SO / SOM ", "252 ");
		add("South Africa ", "ZA / ZAF ", "27 ");
		add("South Korea ", "KR / KOR ", "82 ");
		add("Spain ", "ES / ESP ", "34 ");
		add("Sri Lanka ", "LK / LKA ", "94 ");
		add("Sudan ", "SD / SDN ", "249 ");
		add("Suriname ", "SR / SUR ", "597 ");
		add("Svalbard ", "SJ / SJM ", " ");
		add("Swaziland ", "SZ / SWZ ", "268 ");
		add("Sweden ", "SE / SWE ", "46 ");
		add("Switzerland ", "CH / CHE ", "41 ");
		add("Syria ", "SY / SYR ", "963 ");
		add("Taiwan ", "TW / TWN ", "886 ");
		add("Tajikistan ", "TJ / TJK ", "992 ");
		add("Tanzania ", "TZ / TZA ", "255 ");
		add("Thailand ", "TH / THA ", "66 ");
		add("Timor-Leste ", "TL / TLS ", "670 ");
		add("Togo ", "TG / TGO ", "228 ");
		add("Tokelau ", "TK / TKL ", "690 ");
		add("Tonga ", "TO / TON ", "676 ");
		add("Trinidad and Tobago ", "TT / TTO ", "1 868 ");
		add("Tunisia ", "TN / TUN ", "216 ");
		add("Turkey ", "TR / TUR ", "90 ");
		add("Turkmenistan ", "TM / TKM ", "993 ");
		add("Turks and Caicos Islands ", "TC / TCA ", "1 649 ");
		add("Tuvalu ", "TV / TUV ", "688 ");
		add("Uganda ", "UG / UGA ", "256 ");
		add("Ukraine ", "UA / UKR ", "380 ");
		add("United Arab Emirates ", "AE / ARE ", "971 ");
		add("United Kingdom ", "GB / GBR ", "44 ");
		add("United States ", "US / USA ", "1 ");
		add("Uruguay ", "UY / URY ", "598 ");
		add("US Virgin Islands ", "VI / VIR ", "1 340 ");
		add("Uzbekistan ", "UZ / UZB ", "998 ");
		add("Vanuatu ", "VU / VUT ", "678 ");
		add("Venezuela ", "VE / VEN ", "58 ");
		add("Vietnam ", "VN / VNM ", "84 ");
		add("Wallis and Futuna ", "WF / WLF ", "681 ");
		add("West Bank ", "/  ", "970 ");
		add("Western Sahara ", "EH / ESH ", " ");
		add("Yemen ", "YE / YEM ", "967 ");
		add("Zambia ", "ZM / ZMB ", "260 ");
		add("Zimbabwe ", "ZW / ZWE ", "263 ");
	}
}
